#ifndef _NODE
#define _NODE

#include "pre.h"
#include <malloc.h>
#include <stdio.h>

extern MosList *MosHead;
extern NodeList *NodeHead;
extern PMosList *hash_mos_list;
extern PNodeList *hash_node_list;

class Node {

     public:
	Node();
	~Node();

	DeviceList *insert_device(DeviceList *head, MosList *mos, PinType pintype);
	NodeList *insert_node(NodeList *head, DeviceList *devicelist, char *nodename);
	bool query_in_moslist(char *name, DeviceList *moslist);
	int query_in_hash_node_list(char *name);
	int return_number(char *name);
	void gen_nodelist();
	void gen_mos_list();
	void delete_mos_in_devicelist();

	void gen_np_char_netlist();
	InoutList *insert_output(InoutList *head, InoutList *curr);
	NodeList *get_node(char *nodename);
	void generate_output_pinlist();
	void generate_input_pinlist();
	char *get_vdd(MosList *moshead);
	char *get_gnd(MosList *moshead);
	void delete_vdd_gnd_from_inputlist();
};


#endif
