#include "pre.h"
#include "node.h"
#include <malloc.h>
#include <stdio.h>
#include <cstring>
#include <string>
#include <iostream>
using namespace std;

#define NLAlloc(type,num) (type *)calloc(num,sizeof(type))
#define ionumber 500

extern MosList *MosHead;
extern NodeList *NodeHead;
extern PMosList *hash_mos_list;
extern PNodeList *hash_node_list;
extern InoutList *InputHead;
extern InoutList *OutputHead;
extern int device_biggest;  // define the size of the mosfet hash table
extern int node_biggest;  // define the size of the node hash table

Node::Node()
{
/*
	hash_mos_list = new MosList[device_biggest];
	hash_node_list = new NodeList[node_biggest+ionumber];
	for(int i=0; i<device_biggest; i++)
		hash_mos_list[i] = NULL;
	for(int j=0; j<(node_biggest+ionumber); j++)
		hash_node_list[j] = NULL;
*/
}

Node::~Node()
{
}


DeviceList *
Node::insert_device(DeviceList *head, MosList *mos, PinType pintype) 
{
  DeviceList *current;
  if(head==NULL) 
  {
	head=NLAlloc(DeviceList,1);
	head->devicename = NLAlloc(char, strlen(mos->mosname));
	strcpy(head->devicename, mos->mosname);
	head->devicetype = mos->nptype;
	head->d = NLAlloc(char, strlen(mos->d));
	strcpy(head->d, mos->d);
	head->g = NLAlloc(char, strlen(mos->g));
        strcpy(head->g, mos->g);
	head->s = NLAlloc(char, strlen(mos->s));
        strcpy(head->s, mos->s);
	head->pintype = pintype;
	head->next = NULL;
  }
  else {
	current=NLAlloc(DeviceList,1);
	current->devicename = NLAlloc(char, strlen(mos->mosname));
	strcpy(current->devicename, mos->mosname);
	current->devicetype = mos->nptype;
	current->d = NLAlloc(char, strlen(mos->d));
	strcpy(current->d, mos->d);
	current->g = NLAlloc(char, strlen(mos->g));
        strcpy(current->g, mos->g);
	current->s = NLAlloc(char, strlen(mos->s));
        strcpy(current->s, mos->s);
	current->pintype = pintype;
	current->next = head->next;
	head->next = current;
  }
  return head;
}

NodeList *
Node::insert_node(NodeList *head, DeviceList *devicelist, char *nodename){
  NodeList *current;
  if(head==NULL)
  {
	head=NLAlloc(NodeList,1);
	head->nodename = NLAlloc(char,strlen(nodename));
	strcpy(head->nodename,nodename);
	head->devicelist = devicelist;
	head->pn_node = 0;
	head->next = NULL;
  }
  else {
	current=NLAlloc(NodeList,1);
	current->nodename = NLAlloc(char,strlen(nodename));
	strcpy(current->nodename,nodename);
	current->devicelist = devicelist;
	current->pn_node = 0;
	current->next = head->next;
	head->next = current;
  }
  return head;
}

bool
Node::query_in_moslist(char *name, DeviceList *moslist)
{
        for(DeviceList *curr=moslist; curr!=NULL; curr=curr->next)
        {
                if(!strcmp(name, curr->devicename))
                        return true;
        }
        return false;
}

int
Node::query_in_hash_node_list(char *name)
{
	for(int i=(node_biggest+1); i<(node_biggest+ionumber); i++)
	{
	  if(hash_node_list[i] != NULL)
	  {
		if(!strcmp(hash_node_list[i]->nodename, name))
			return i;
	  }
	}
	return -1;
}

	
int
Node::return_number(char *name)
{
        char *st = NLAlloc(char, strlen(name));
        strcpy(st, name);
        char *ret=NULL;
        ret = NLAlloc(char, strlen(st));
        int counter = 0;

        bool begin_f=false;
        bool end_f=false;

        int i=0;
        while(st[i]!='\0')
        {
                if(st[i]>=48 && st[i]<=57 && st[i]!='\0')
                {
                        begin_f = true;
                        ret[counter]=st[i];
                        counter+=1;
                }
                if(begin_f && st[i]!='\0' && ( st[i]<48 || st[i]>57 ))
                {
                        end_f = true;
                        break;
                }
                i+=1;
        }

        ret[counter] =  '\0';

        if(begin_f && !end_f)
        {
                return atoi(ret);
        }
        else
        {
                return -1;
        }
}

void Node::gen_nodelist()
{
		int counter=1;
        for(MosList *curr_mos=MosHead; curr_mos!=NULL; curr_mos=curr_mos->next)
        {
//			printf("mosname: %s\n", curr_mos->mosname);
            int noded = return_number(curr_mos->d);
            int nodeg = return_number(curr_mos->g);
            int nodes = return_number(curr_mos->s);
//			printf(" d: %d, g: %d, s: %d \n", noded, nodeg, nodes);
			if( noded!= -1)
			{
                if(hash_node_list[noded] == NULL)
                {
                        hash_node_list[noded] = NLAlloc(NodeList,1);
                        hash_node_list[noded]->nodename = NLAlloc(char, strlen(curr_mos->d));
                        strcpy(hash_node_list[noded]->nodename, curr_mos->d);

						hash_node_list[noded]->terminal = false;
						hash_node_list[noded]->wire = false;
						hash_node_list[noded]->connected_p_branch_name = NULL;
						hash_node_list[noded]->connected_n_branch_name = NULL;
						hash_node_list[noded]->output_of_gate_name = NULL;
						hash_node_list[noded]->input_of_gate_list = NULL;
						hash_node_list[noded]->output_of_trans_name = NULL;
						hash_node_list[noded]->input_of_trans_name = NULL;
						

                    	hash_node_list[noded]->devicelist = insert_device(hash_node_list[noded]->devicelist,curr_mos,DP);
                }
                else
                {
                        if(!query_in_moslist(curr_mos->mosname, hash_node_list[noded]->devicelist))
                        {
                    		hash_node_list[noded]->devicelist = insert_device(hash_node_list[noded]->devicelist,curr_mos, DP);
                        }
                }
			}
			else
			{
//				printf("reach here\n");
				int rval = query_in_hash_node_list(curr_mos->d);
//					printf("rval: %d", rval);
				if(	rval == -1)
				{
                    hash_node_list[node_biggest+counter] = NLAlloc(NodeList,1);
                    hash_node_list[node_biggest+counter]->nodename = NLAlloc(char, strlen(curr_mos->d));
                    strcpy(hash_node_list[node_biggest+counter]->nodename, curr_mos->d);

						hash_node_list[node_biggest+counter]->terminal = false;
						hash_node_list[node_biggest+counter]->wire = false;
						hash_node_list[node_biggest+counter]->connected_p_branch_name = NULL;
						hash_node_list[node_biggest+counter]->connected_n_branch_name = NULL;
						hash_node_list[node_biggest+counter]->output_of_gate_name = NULL;
						hash_node_list[node_biggest+counter]->input_of_gate_list = NULL;
						hash_node_list[node_biggest+counter]->output_of_trans_name = NULL;
						hash_node_list[node_biggest+counter]->input_of_trans_name = NULL;

                    hash_node_list[node_biggest+counter]->devicelist = insert_device(hash_node_list[node_biggest+counter]->devicelist,curr_mos,DP);
					counter+=1;
				}
				else
				{
                        if(!query_in_moslist(curr_mos->mosname, hash_node_list[rval]->devicelist))
                        {
                    		hash_node_list[rval]->devicelist = insert_device(hash_node_list[rval]->devicelist,curr_mos, DP);
                        }
				}
			}

			if(nodeg != -1)
			{
                if(hash_node_list[nodeg] == NULL)
                {
                        hash_node_list[nodeg] = NLAlloc(NodeList,1);
                        hash_node_list[nodeg]->nodename = NLAlloc(char, strlen(curr_mos->g));
                        strcpy(hash_node_list[nodeg]->nodename, curr_mos->g);

						hash_node_list[nodeg]->terminal = false;
						hash_node_list[nodeg]->wire = false;
						hash_node_list[nodeg]->connected_p_branch_name = NULL;
						hash_node_list[nodeg]->connected_n_branch_name = NULL;
						hash_node_list[nodeg]->output_of_gate_name = NULL;
						hash_node_list[nodeg]->input_of_gate_list = NULL;
						hash_node_list[nodeg]->output_of_trans_name = NULL;
						hash_node_list[nodeg]->input_of_trans_name = NULL;

                    	hash_node_list[nodeg]->devicelist = insert_device(hash_node_list[nodeg]->devicelist, curr_mos, GP);
                }
                else
                {
                        if(!query_in_moslist(curr_mos->mosname, hash_node_list[nodeg]->devicelist))
                        {
                    		hash_node_list[nodeg]->devicelist = insert_device(hash_node_list[nodeg]->devicelist,curr_mos,GP);
                        }
                }
			}
			else
			{
				int rval = query_in_hash_node_list(curr_mos->g);
				if(	rval == -1)
				{
                    hash_node_list[node_biggest+counter] = NLAlloc(NodeList,1);
                    hash_node_list[node_biggest+counter]->nodename = NLAlloc(char, strlen(curr_mos->g));
                    strcpy(hash_node_list[node_biggest+counter]->nodename, curr_mos->g);

						hash_node_list[node_biggest+counter]->terminal = false;
						hash_node_list[node_biggest+counter]->wire = false;
						hash_node_list[node_biggest+counter]->connected_p_branch_name = NULL;
						hash_node_list[node_biggest+counter]->connected_n_branch_name = NULL;
						hash_node_list[node_biggest+counter]->output_of_gate_name = NULL;
						hash_node_list[node_biggest+counter]->input_of_gate_list = NULL;
						hash_node_list[node_biggest+counter]->output_of_trans_name = NULL;
						hash_node_list[node_biggest+counter]->input_of_trans_name = NULL;

                    hash_node_list[node_biggest+counter]->devicelist = insert_device(hash_node_list[node_biggest+counter]->devicelist,curr_mos,GP);
					counter+=1;
				}
				else
				{
                        if(!query_in_moslist(curr_mos->mosname, hash_node_list[rval]->devicelist))
                        {
                    		hash_node_list[rval]->devicelist = insert_device(hash_node_list[rval]->devicelist,curr_mos, GP);
                        }
				}
			}

			if(nodes != -1)
			{
                if(hash_node_list[nodes] == NULL)
                {
                        hash_node_list[nodes] = NLAlloc(NodeList,1);
                        hash_node_list[nodes]->nodename = NLAlloc(char, strlen(curr_mos->s));
                        strcpy(hash_node_list[nodes]->nodename, curr_mos->s);

						hash_node_list[nodes]->terminal = false;
						hash_node_list[nodes]->wire = false;
						hash_node_list[nodes]->connected_p_branch_name = NULL;
						hash_node_list[nodes]->connected_n_branch_name = NULL;
						hash_node_list[nodes]->output_of_gate_name = NULL;
						hash_node_list[nodes]->input_of_gate_list = NULL;
						hash_node_list[nodes]->output_of_trans_name = NULL;
						hash_node_list[nodes]->input_of_trans_name = NULL;

                    	hash_node_list[nodes]->devicelist = insert_device(hash_node_list[nodes]->devicelist, curr_mos,SP);
                }
                else
                {
                        if(!query_in_moslist(curr_mos->mosname, hash_node_list[nodes]->devicelist))
                        {
                    		hash_node_list[nodes]->devicelist = insert_device(hash_node_list[nodes]->devicelist,curr_mos, SP);
                        }
                }
			}
			else
			{
				int rval = query_in_hash_node_list(curr_mos->s);
				if(	rval == -1)
				{
                    hash_node_list[node_biggest+counter] = NLAlloc(NodeList,1);
                    hash_node_list[node_biggest+counter]->nodename = NLAlloc(char, strlen(curr_mos->s));
                    strcpy(hash_node_list[node_biggest+counter]->nodename, curr_mos->s);

						hash_node_list[node_biggest+counter]->terminal = false;
						hash_node_list[node_biggest+counter]->wire = false;
						hash_node_list[node_biggest+counter]->connected_p_branch_name = NULL;
						hash_node_list[node_biggest+counter]->connected_n_branch_name = NULL;
						hash_node_list[node_biggest+counter]->output_of_gate_name = NULL;
						hash_node_list[node_biggest+counter]->input_of_gate_list = NULL;
						hash_node_list[node_biggest+counter]->output_of_trans_name = NULL;
						hash_node_list[node_biggest+counter]->input_of_trans_name = NULL;

                    hash_node_list[node_biggest+counter]->devicelist = insert_device(hash_node_list[node_biggest+counter]->devicelist,curr_mos,SP);
					counter+=1;
				}
				else
				{
                        if(!query_in_moslist(curr_mos->mosname, hash_node_list[rval]->devicelist))
                        {
                    		hash_node_list[rval]->devicelist = insert_device(hash_node_list[rval]->devicelist,curr_mos, SP);
                        }
				}
			}
	}
}

// Generate hash_mos_list
void
Node::gen_mos_list()
{
    for(MosList *curr_mos=MosHead; curr_mos!=NULL; curr_mos=curr_mos->next)
    {
		int rval = return_number(curr_mos->mosname);
		if(rval!=-1)
		{
			hash_mos_list[rval] = curr_mos;
		}
		else
		{
			cout<<"The name of the Mosfet is wrong, please check"<<endl;
		}
	}
}

void Node::gen_np_char_netlist()
{
   for(int i=0; i<(node_biggest+ionumber); i++)
   { 
	if(hash_node_list[i]!=NULL)
	{
	int p_flag=0;
	int n_flag=0;
	for(DeviceList *cur_device=hash_node_list[i]->devicelist; cur_device!=NULL; cur_device=cur_device->next)
	{
	   if((cur_device->devicetype==0) && (cur_device->pintype!=GP))
		n_flag=1;
	   if((cur_device->devicetype==1) && (cur_device->pintype!=GP))
		p_flag=1;
	}
	
	if(p_flag && n_flag)
		hash_node_list[i]->pn_node = 1;
	}
   }
}

char *
Node::get_vdd(MosList *moshead)
{
   char *vdd;
   MosList *curr = NULL;
   for(curr=moshead; curr!=NULL; curr=curr->next)
   {
        if(curr->nptype)
        {
          vdd = NLAlloc(char,strlen(curr->b));
          strcpy(vdd, curr->b);
          break;
        }
   }
   return vdd;
}

char *
Node::get_gnd(MosList *moshead)
{
   char *gnd;
   MosList *curr = NULL;
   for(curr=moshead; curr!=NULL; curr=curr->next)
   {
        if(!curr->nptype)
        {
          gnd = NLAlloc(char,strlen(curr->b));
          strcpy(gnd, curr->b);
          break;
        }
   }
   return gnd;
}

void
Node::delete_vdd_gnd_from_inputlist()
{
    char *vdd = get_vdd(MosHead);
    char *gnd = get_gnd(MosHead);


//    printf("%s %s", vdd, gnd);
    InoutList *curr, *prev;
    curr = InputHead->next;
    prev = InputHead;
    while(curr!=NULL)
    {
        if(!strcmp(curr->pinname, vdd) || !strcmp(curr->pinname, gnd))
        {
            prev->next = curr->next;
            curr = prev->next;
        }
        else
        {
            prev=curr;
            curr=curr->next;
        }
    }
}


InoutList *
Node::insert_output(InoutList *head, InoutList *curr)
{
    InoutList *current;
    if(head==NULL)
    {
	head=NLAlloc(InoutList,1);
	head->pinname = NLAlloc(char, strlen(curr->pinname));
	strcpy(head->pinname, curr->pinname);
	head->next=NULL;
    }
    else
    {
	current=NLAlloc(InoutList,1);
	current->pinname = NLAlloc(char, strlen(curr->pinname));
	strcpy(current->pinname, curr->pinname);
	current->next = head->next;
	head->next = current;
    }
    return head;
}

NodeList *
Node::get_node(char *nodename)
{
        int rval = return_number(nodename);
        if(rval != -1)
                return hash_node_list[rval];
        else
        {
                for(int i=node_biggest+1; i<(node_biggest+ionumber); i++)
                {
                  if(hash_node_list[i] != NULL)
                  {
                        if(!strcmp(nodename, hash_node_list[i]->nodename))
                                return hash_node_list[i];
                  }
                }
        }
}
	
void
Node::generate_output_pinlist()
{
    for(InoutList *curr=InputHead->next; curr!=NULL; curr=curr->next)
    {
	int flag=0;
	NodeList *node_h = get_node(curr->pinname);
		node_h->terminal = true;

		for(DeviceList *curr_dev=node_h->devicelist; curr_dev!=NULL; curr_dev=curr_dev->next)
		{
		    if(curr_dev->pintype!=GP)
		    {
			flag=1;
			break;
		    }
		}

	if(flag)
	    OutputHead = insert_output(OutputHead, curr);
    }
}

void
Node::generate_input_pinlist()
{
    InoutList *curr_input, *prev_input;
    prev_input = InputHead;
    curr_input = prev_input->next;
    while(curr_input!=NULL)
    {
	int flag=0;
	for(InoutList *curr_out=OutputHead; curr_out!=NULL; curr_out=curr_out->next)
	{
	    if(!strcmp(curr_out->pinname, curr_input->pinname))
	    {
		flag=1;
		break;
	    }
	}
	if(flag)
	{
	    prev_input->next = curr_input->next;
	    curr_input = prev_input->next;
	}
	else
	{
	    prev_input = curr_input;
	    curr_input = curr_input->next;
	}
    }
}

