#ifndef _PATTERNMATCH
#define _PATTERNMATCH

#include "pre.h"
#include "tellnp.h"
#include "node.h"
#include "branch.h"
#include "group.h"
#include "cgate.h"
#include "macromodel.h"
#include <malloc.h>
#include <stdio.h>
#include <string>
#include <cstring>

#define NLAlloc(type,num) (type *)calloc(num,sizeof(type))
#define ionumber 500

class Patternmatch {

    public:
	Macromodel *macromodel;

	Patternmatch(Macromodel *a_macromodel);
	~Patternmatch();

	bool decide_a_gate(char *name);
	int return_number(char *name);
	NodeList * get_node(char *nodename);
	RGList *insert_return_gate(RGList *head, char *name, int type);
	RGList *return_a_gate_list(char *gatename);
	RGList *return_a_trans_input_list(char *gatename);
	RGList *return_a_trans_output_list(char *gatename);
	void unique_rglist(RGList *glist);
	void fill_gate_node_in_stack(char *mname, char *cname);
	void fill_trans_node_in_stack(char *mname, char *cname);
	int count_num_of_rglist(RGList *glist);
	int count_num_of_a_list(PinList *plist);
	bool decide_two_pinlist_same(char *mnode_name, char *cnode_name);
	bool decide_failed(RGList *mglist, RGList *cglist, int mnum, int cnum, bool ter);
	bool fill_in_gate_stack(RGList *mglist, RGList *cglist, bool ter);
	int step();
	bool query_in_pinlist(char *name, PinList *plist);
	char * case_one_gate(char *mgate_name,PinList *plist);
	char * case_more_than_one_gate(char *mgate_name, PinList *plist);
	void deal_with_dead_loop();
	bool query_in_gatename_list(char *name, GateNameList *gnlist);
	char * compare_two_gatename_list(GateNameList *returen_list, GateNameList *real_list);
	char * return_nbranch_matched_pinname(GateNameList *valid_list, CGate *hgate);
	char * return_pbranch_matched_pinname(GateNameList *valid_list, CGate *hgate);
	char * case_one_gate_for_a_pin(char *pinname,CGate *hgate);
	char * case_more_than_one_gate_for_a_pin(PinList *plist);
	void input_output_matching();
	int count_num_of_gatename_list(GateNameList *gnlist);
	bool node_not_found_yet(char *name);
	bool gatename_list_not_found_yet(GateNameList *gnlist);
	void related_pin_recognition();
	bool query_in_inputlist(char *name);
	EqualNameList * insert_equal_name(EqualNameList *head, char *mname, char *cname);
	ResultList *generate_result_list(ResultList *head, char *name, EqualNameList *inputlist, EqualNameList *outputlist);
	PinList *insert_pin(PinList *head, char *name);
	PinList * delete_one_in_pinlist(char *name, PinList *plist);
	void delete_found_gates_trans();
	void delete_the_connection_of_terminal(EqualNameList *inputlist, EqualNameList *outputlist);
	void pattern_match_process();
	
};

#endif
