
# line 2 "bas.y"
#include "pre.h"
#include <stdio.h>

char *subname;
char *macromodelname;
char *modelname;

Element *element_list_header;
MosList *mos_list_header;
BipolarList *bipolar_list_header;
TerminalList *terminal_list_header;
ModelList *model_list_header;
char *name_of_macro_model;
int flag;

extern int yywrap();
extern void yyerror(char *s);

# line 21 "bas.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
{
char svalue[300];
int ivalue;
float fvalue;
} YYSTYPE;
# define NODENAME 257
# define RESISTOR 258
# define INDUCTOR 259
# define CAPACITOR 260
# define VCCS 261
# define VCVS 262
# define INTEGER 263
# define VOLTAGE_SOURCE 264
# define CURRENT_SOURCE 265
# define CCCS 266
# define CCVS 267
# define DIODE 268
# define MOSFET 269
# define VALUE 270
# define TRANSIENT 271
# define SUBCKT 272
# define MACROMODEL 273
# define MODELL 274
# define ENDS 275
# define ENDMACROMODEL 276
# define BIPOLAR 277
# define PRINT 278
# define OPTION 279
# define DC 280

#include <inttypes.h>

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#define	YYCONST	const
#else
#include <malloc.h>
#include <memory.h>
#define	YYCONST
#endif

#include <values.h>

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
#ifndef yyerror
#if defined(__cplusplus)
	void yyerror(YYCONST char *);
#endif
#endif
#ifndef yylex
	int yylex(void);
#endif
	int yyparse(void);
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#endif

#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 249 "bas.y"


void yyerror(char const *s) {
     fprintf(stdout,"%s\n",s);
     }


extern Element *ElementHead;
PinList *PinHead=NULL;
#include <malloc.h>
#define NLAlloc(type,num) (type *)calloc(num,sizeof(type))
PinList *tail;

PinList *insert_node(PinList *head, char *NodeName) {
PinList *current;
if(head==NULL) {
   head=NLAlloc(PinList,1);
   head->NodeName=NLAlloc(char, strlen(NodeName));
   strcpy(head->NodeName, NodeName);
   head->next=NULL;
   tail=head;
} 
else {
   current=NLAlloc(PinList,1);
   current->NodeName=NLAlloc(char, strlen(NodeName));
   strcpy(current->NodeName, NodeName);
   current->next=NULL;
   tail->next=current;
   tail=tail->next;
}
return head;
}


Element *insert_element(char *name, Element *head, ElementType type, PinList *nodelist,float value, char *Model, float lvalue, float wvalue) {

Element *current;

if(head==NULL) {
   head=NLAlloc(Element,1);
   head->type = type;
   head->name = NLAlloc(char,strlen(name));
   strcpy(head->name,name);

   head->nodelist = nodelist;
   head->value=value;
   head->l_value = lvalue;
   head->Model = NLAlloc(char,strlen(Model));
   strcpy(head->Model,Model);
   head->w_value = wvalue;
   head->next=NULL;
}
else {
   current=NLAlloc(Element,1);
   current->type = type;
   current->name = NLAlloc(char,strlen(name));
   strcpy(current->name,name);

   current->nodelist=nodelist;
   current->value=value;
   current->Model = NLAlloc(char,strlen(Model));
   strcpy(current->Model,Model);
   current->l_value = lvalue;
   current->w_value = wvalue;
   current->next = head->next;
   head->next=current;
}
return head;
}

extern BipolarList *BipolarHead;
BipolarList *insert_bipolar(BipolarList *head, char *name, char *c, char *b, char *e, char *modelname) {
BipolarList *current;

if(head==NULL) {
	head = NLAlloc(BipolarList, 1);
	head->name = NLAlloc(char, strlen(name));
	strcpy(head->name, name);
	head->c = NLAlloc(char, strlen(c));
	strcpy(head->c, c);
	head->b = NLAlloc(char, strlen(b));
	strcpy(head->b, b);
	head->e = NLAlloc(char, strlen(e));
	strcpy(head->e, e);
	head->modelname = NLAlloc(char, strlen(modelname));
	strcpy(head->modelname, modelname);
	head->next = NULL;
}
else {
	current = NLAlloc(BipolarList, 1);
	current->name = NLAlloc(char, strlen(name));
	strcpy(current->name, name);
	current->c = NLAlloc(char, strlen(c));
	strcpy(current->c, c);
	current->b = NLAlloc(char, strlen(b));
	strcpy(current->b, b);
	current->e = NLAlloc(char, strlen(e));
	strcpy(current->e, e);
	current->modelname = NLAlloc(char, strlen(modelname));
	strcpy(current->modelname, modelname);
	current->next = head->next;
	head->next = current;
}
return head;
}



extern MosList *MosHead;

MosList *insert_mos(MosList *head, char *mosname, char *d, char *g, char *s, char *b, char *modelname, float lvalue, float wvalue) {

MosList *current;

if(head==NULL) {
        head = NLAlloc(MosList,1);
        head->mosname = NLAlloc(char,strlen(mosname));
        strcpy(head->mosname,mosname);
        head->d = NLAlloc(char,strlen(d));
        strcpy(head->d,d);
        head->g = NLAlloc(char,strlen(g));
        strcpy(head->g,g);
        head->s = NLAlloc(char,strlen(s));
        strcpy(head->s,s);
        head->nptype = 0;
        head->is_instead = 0;
        head->b = NLAlloc(char,strlen(b));
        strcpy(head->b,b);
        head->modelname = NLAlloc(char,strlen(modelname));
        strcpy(head->modelname,modelname);
        head->lvalue = lvalue;
        head->wvalue = wvalue;
        head->in_branch = false;
        head->next = NULL;
}
else {
        current = NLAlloc(MosList,1);
        current->mosname = NLAlloc(char, strlen(mosname));
        strcpy(current->mosname,mosname);
        current->d = NLAlloc(char, strlen(d));
        strcpy(current->d,d);
        current->g = NLAlloc(char, strlen(g));
        strcpy(current->g,g);
        current->s = NLAlloc(char, strlen(s));
        strcpy(current->s,s);
        current->nptype = 0;
        current->is_instead = 0;
        current->b = NLAlloc(char, strlen(b));
        strcpy(current->b,b);
        current->modelname = NLAlloc(char, strlen(modelname));
        strcpy(current->modelname,modelname);
        current->lvalue = lvalue;
        current->wvalue = wvalue;
        current->in_branch = false;
        current->next = head->next;
        head->next = current;
}
return head;
}

extern ModelList *ModelHead;

ModelList *insert_model(ModelList *head,ModelType type,char *name_, char *_npmos,float is_,float vt_,float k_,float vth_,float lambda_)    {

ModelList *current;

if(head==NULL) {
        head=NLAlloc(ModelList,1);
        head->type = type;
        head->name = NLAlloc(char,strlen(name_));
        strcpy(head->name,name_);
        head->npmos = NLAlloc(char,strlen(_npmos));
        strcpy(head->npmos,_npmos);
        head->is = is_;
        head->vt = vt_;
        head->k = k_;
        head->vth = vth_;
        head->lambda = lambda_;
        head->next = NULL;
}
else {
        current=NLAlloc(ModelList,1);
        current->type = type;
        current->name = NLAlloc(char,strlen(name_));
        strcpy(current->name,name_);
        current->npmos = NLAlloc(char,strlen(_npmos));
        strcpy(current->npmos,_npmos);
        current->is = is_;
        current->vt = vt_;
        current->k = k_;
        current->vth = vth_;
        current->lambda = lambda_;
        current->next = head->next;
        head->next = current;
}
return head;
}

extern Action *ActionHead;

Action *insert_action(Action *head, ActionType type, float value_1, float value_2,int v_, float start_, float end_, float step_, char *name_) {

Action *current;

if(head==NULL) {
	head = NLAlloc(Action,1);
	head->type = type;
	head->value1 = value_1;
//	printf("%e \n",head->value1);
	head->value2 = value_2;
	head->v = v_;
	head->start = start_;
	head->end = end_;
	head->step = step_;
        head->name = NLAlloc(char,strlen(name_));
        strcpy(head->name,name_);
//	printf("%e \n",head->value2);
	head->next = NULL;
}
else {
	current = NLAlloc(Action,1);
	current->type = type;
	current->value1 = value_1;
	current->value2 = value_2;
	current->v = v_;
	current->start = start_;
	current->end = end_;
	current->step = step_;
        current->name = NLAlloc(char,strlen(name_));
        strcpy(current->name,name_);
	current->next = head->next;
	head->next = current;
}
return head;
}



extern InoutList *InputHead;

void insert_inout(char *name)
{
  char *st = NLAlloc(char, strlen(name));
  strcpy(st, name);
  InoutList *current;
  char *new_str=NLAlloc(char,20);
  int globe=0;
  int counter=0;
  while(*st++)
  {
    if(*st==' ' || *st=='\n')
    {
        globe += 1;
        new_str[counter]='\0';
        counter=0;
  if(globe>1)
  {
    if(InputHead==NULL)
    {
        InputHead=NLAlloc(InoutList,1);
        InputHead->pinname=NLAlloc(char, strlen(new_str));
        strcpy(InputHead->pinname, new_str);
        InputHead->next = NULL;
    }
    else
    {
        current=NLAlloc(InoutList,1);
        current->pinname=NLAlloc(char,strlen(new_str));
        strcpy(current->pinname, new_str);
        current->next = InputHead->next;
        InputHead->next = current;
    }
  }

        delete new_str;
        char *new_str = NLAlloc(char,20);
    }
    else
    {
        new_str[counter]=*st;
        counter+=1;
    }
  }

}

void insert_terminal(char *name)
{
  char *st = NLAlloc(char, strlen(name));
  strcpy(st, name);
  TerminalList *current;
  char *new_str=NLAlloc(char,20);
  int globe=0;
  int counter=0;
  while(*st++)
  {
    if(*st==' ' || *st=='\n')
    {
        globe += 1;
        new_str[counter]='\0';
        counter=0;
  if(globe>1 && globe<=2)
  {
	    name_of_macro_model = NLAlloc(char, strlen(new_str));
	    strcpy(name_of_macro_model, new_str);
  }
  else if(globe>2)
  {
    if(terminal_list_header==NULL)
    {
        terminal_list_header=NLAlloc(TerminalList,1);
        terminal_list_header->name=NLAlloc(char, strlen(new_str));
        strcpy(terminal_list_header->name, new_str);
        terminal_list_header->next = NULL;
    }
    else
    {
        current=NLAlloc(TerminalList,1);
        current->name=NLAlloc(char,strlen(new_str));
        strcpy(current->name, new_str);
        current->next = terminal_list_header->next;
        terminal_list_header->next = current;
    }
  }
  else
  ;

        delete new_str;
        char *new_str = NLAlloc(char,20);
    }
    else
    {
        new_str[counter]=*st;
        counter+=1;
    }
  }

}

extern MacroModelList *MacroModelHead;

MacroModelList *insert_macro_model(MacroModelList *head, char *name, TerminalList *terminal_list, Element *element_list, MosList *mos_list, BipolarList *bipolar_list, ModelList *model_list)
{
MacroModelList *current;

if(head==NULL) {
	head = NLAlloc(MacroModelList, 1);
	head->macromodel_name = NLAlloc(char, strlen(name));
	strcpy(head->macromodel_name, name);
	head->terminal_list = terminal_list;
	head->element_list = element_list;
	head->mos_list = mos_list;
	head->bipolar_list = bipolar_list;
	head->model_list = model_list;
	head->num_of_mos = 0;
	head->done = false;
	head->flag = 0;
	head->next = NULL;
}
else {
	current = NLAlloc(MacroModelList,1);
	current->macromodel_name = NLAlloc(char, strlen(name));
	strcpy(current->macromodel_name, name);
	current->terminal_list = terminal_list;
	current->element_list = element_list;
	current->mos_list = mos_list;
	current->bipolar_list = bipolar_list;
	current->model_list = model_list;
	current->num_of_mos = 0;
	current->flag = 0;
	current->done = false;
	current->next = head->next;
	head->next = current;
}	
return head;
}

static YYCONST yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 50
# define YYLAST 240
static YYCONST yytabelem yyact[]={

    33,    35,    34,    36,    37,   129,    38,    39,    40,    41,
    42,    43,    85,    24,    25,    26,    27,    32,    28,    29,
    30,    31,    44,    46,   108,   124,    51,   123,   116,   115,
    47,    47,    50,   114,   113,    99,    95,    83,    68,    66,
    53,    48,    45,   130,   126,   125,   119,   118,   117,    98,
   100,    70,    23,    22,    21,    20,    19,    18,    17,    16,
    15,    14,    13,    12,    11,    10,     9,     8,     7,     6,
     5,     4,     3,     2,     1,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    67,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    82,
     0,     0,     0,     0,    86,    87,    88,     0,     0,    91,
    92,     0,     0,     0,     0,    97,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   106,   107,    49,     0,   109,   110,   111,   112,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   120,   121,   122,     0,     0,     0,     0,     0,   127,   128,
     0,     0,    52,   131,     0,    54,    55,    56,    57,    58,
    59,    60,    61,    62,    63,    64,    65,     0,     0,     0,
     0,     0,     0,     0,     0,    69,     0,     0,    71,    72,
    73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
     0,     0,    84,     0,     0,     0,     0,    89,    90,     0,
     0,    93,    94,     0,    96,     0,     0,     0,     0,     0,
     0,     0,   101,   102,     0,     0,   103,   104,     0,   105 };
static YYCONST yytabelem yypact[]={

-10000000,  -258,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,  -240,-10000000,-10000000,  -216,  -231,  -231,
  -217,-10000000,  -231,  -231,  -231,  -231,  -231,  -231,  -231,  -231,
  -231,  -231,  -231,  -231,  -218,  -240,-10000000,-10000000,  -219,-10000000,
-10000000,-10000000,  -231,    11,-10000000,  -231,  -231,  -231,  -231,  -231,
  -231,  -231,  -231,  -231,  -231,  -231,  -240,-10000000,  -220,  -231,
  -251,  -240,  -240,  -240,  -231,  -231,  -240,  -240,  -231,  -231,
  -221,  -231,  -240,   -12,  -222,     9,-10000000,-10000000,-10000000,  -231,
  -231,-10000000,-10000000,  -231,  -231,-10000000,  -231,  -240,  -239,-10000000,
-10000000,  -240,  -240,  -240,  -240,  -223,-10000000,  -224,  -228,-10000000,
-10000000,-10000000,-10000000,  -229,   -13,   -14,   -15,  -240,  -240,  -240,
-10000000,  -230,  -232,   -16,   -17,  -240,  -240,  -252,-10000000,   -18,
  -240,-10000000 };
static YYCONST yytabelem yypgo[]={

     0,    74,    73,    72,    71,    70,    69,    68,    67,    66,
    65,    64,    63,    62,    61,    60,    59,    58,    57,    56,
    55,    54,    53,    52,   142,    42 };
static YYCONST yytabelem yyr1[]={

     0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,    24,    24,    25,    25,     2,    12,
    13,    14,    17,     9,    10,    11,     3,     4,     5,     6,
     7,    23,    18,    16,    15,    19,    20,    21,    22,     8 };
static YYCONST yytabelem yyr2[]={

     0,     0,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     3,     2,     3,     2,     7,     9,
     9,     9,     9,    11,     3,     5,     3,     3,    19,    31,
     5,    11,     9,    13,    13,    13,    13,     9,    25,    11 };
static YYCONST yytabelem yychk[]={

-10000000,    -1,    -2,    -3,    -4,    -5,    -6,    -7,    -8,    -9,
   -10,   -11,   -12,   -13,   -14,   -15,   -16,   -17,   -18,   -19,
   -20,   -21,   -22,   -23,   271,   272,   273,   274,   276,   277,
   278,   279,   275,   258,   260,   259,   261,   262,   264,   265,
   266,   267,   268,   269,   280,   -25,   263,   270,   257,   -24,
   263,   257,   -24,   257,   -24,   -24,   -24,   -24,   -24,   -24,
   -24,   -24,   -24,   -24,   -24,   -24,   257,   -25,   257,   -24,
    40,   -24,   -24,   -24,   -24,   -24,   -24,   -24,   -24,   -24,
   -24,   -24,   -25,   257,   -24,   263,   -25,   -25,   -25,   -24,
   -24,   -25,   -25,   -24,   -24,   257,   -24,   -25,    61,   257,
    41,   -24,   -24,   -24,   -24,   -24,   -25,   -25,   263,   -25,
   -25,   -25,   -25,   257,   257,   257,   257,    61,    61,    61,
   -25,   -25,   -25,   257,   257,    61,    61,   -25,   -25,   257,
    61,   -25 };
static YYCONST yytabelem yydef[]={

     1,    -2,     2,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,     0,    36,    37,     0,     0,     0,
     0,    34,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    26,    27,     0,    40,
    24,    25,     0,     0,    35,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    28,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    29,    30,    31,     0,
     0,    32,    42,     0,     0,    47,     0,     0,     0,    49,
    33,     0,     0,     0,     0,     0,    41,     0,     0,    44,
    43,    45,    46,     0,     0,     0,     0,     0,     0,     0,
    38,     0,     0,     0,     0,     0,     0,     0,    48,     0,
     0,    39 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"NODENAME",	257,
	"RESISTOR",	258,
	"INDUCTOR",	259,
	"CAPACITOR",	260,
	"VCCS",	261,
	"VCVS",	262,
	"INTEGER",	263,
	"VOLTAGE_SOURCE",	264,
	"CURRENT_SOURCE",	265,
	"CCCS",	266,
	"CCVS",	267,
	"DIODE",	268,
	"MOSFET",	269,
	"VALUE",	270,
	"TRANSIENT",	271,
	"SUBCKT",	272,
	"MACROMODEL",	273,
	"MODELL",	274,
	"ENDS",	275,
	"ENDMACROMODEL",	276,
	"BIPOLAR",	277,
	"PRINT",	278,
	"OPTION",	279,
	"DC",	280,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"element : /* empty */",
	"element : element tran_analysis",
	"element : element subckt",
	"element : element macromodel",
	"element : element diode_model",
	"element : element mosfet_model",
	"element : element endmacromodel",
	"element : element bipolar",
	"element : element print",
	"element : element option",
	"element : element ends",
	"element : element resistor",
	"element : element capacitor",
	"element : element inductor",
	"element : element vccs",
	"element : element vcvs",
	"element : element voltage_source",
	"element : element current_source",
	"element : element cccs",
	"element : element ccvs",
	"element : element diode",
	"element : element mosfet",
	"element : element dc_analysis",
	"node : INTEGER",
	"node : NODENAME",
	"value : INTEGER",
	"value : VALUE",
	"tran_analysis : TRANSIENT value value",
	"resistor : RESISTOR node node value",
	"capacitor : CAPACITOR node node value",
	"inductor : INDUCTOR node node value",
	"voltage_source : VOLTAGE_SOURCE node node value",
	"print : PRINT NODENAME '(' INTEGER ')'",
	"option : OPTION",
	"ends : ENDS node",
	"subckt : SUBCKT",
	"macromodel : MACROMODEL",
	"diode_model : MODELL NODENAME NODENAME NODENAME '=' value NODENAME '=' value",
	"mosfet_model : MODELL NODENAME NODENAME NODENAME '=' INTEGER NODENAME '=' value NODENAME '=' value NODENAME '=' value",
	"endmacromodel : ENDMACROMODEL node",
	"dc_analysis : DC NODENAME value value value",
	"current_source : CURRENT_SOURCE node node value",
	"vcvs : VCVS node node node node value",
	"vccs : VCCS node node node node value",
	"cccs : CCCS node node node node value",
	"ccvs : CCVS node node node node value",
	"diode : DIODE node node NODENAME",
	"mosfet : MOSFET node node node node NODENAME NODENAME '=' value NODENAME '=' value",
	"bipolar : BIPOLAR node node node NODENAME",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.16	99/01/20 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			long yyps_index = (yy_ps - yys);
			long yypv_index = (yy_pv - yyv);
			long yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register YYCONST int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 24:
# line 80 "bas.y"
{ sprintf(yyval.svalue, "%d\0", yypvt[-0].ivalue); } break;
case 26:
# line 84 "bas.y"
{ yyval.fvalue = yypvt[-0].ivalue; } break;
case 28:
# line 88 "bas.y"
{ActionHead = insert_action(ActionHead,TRAN,yypvt[-1].fvalue,yypvt[-0].fvalue,0,0.0,0.0,0.0,"yz");  
	} break;
case 29:
# line 92 "bas.y"
{PinHead=insert_node(NULL,yypvt[-2].svalue);
				    PinHead=insert_node(PinHead,yypvt[-1].svalue);
				    if(flag==1)
				    ElementHead=insert_element(yypvt[-3].svalue,ElementHead,RES,PinHead,yypvt[-0].fvalue,"",0.0,0.0); 
				    else
				    element_list_header = insert_element(yypvt[-3].svalue,element_list_header,RES,PinHead,yypvt[-0].fvalue,"",0.0,0.0);
				    } break;
case 30:
# line 102 "bas.y"
{PinHead=insert_node(NULL,yypvt[-2].svalue);
				      PinHead=insert_node(PinHead,yypvt[-1].svalue);
			 	      if(flag==1)		
				      ElementHead=insert_element(yypvt[-3].svalue,ElementHead,CAP,PinHead,yypvt[-0].fvalue,"",0.0,0.0); 
				      else
				      element_list_header = insert_element(yypvt[-3].svalue,element_list_header,CAP,PinHead,yypvt[-0].fvalue,"",0.0,0.0);
				      } break;
case 31:
# line 112 "bas.y"
{PinHead=insert_node(NULL,yypvt[-2].svalue);
				    PinHead=insert_node(PinHead,yypvt[-1].svalue);
				    if(flag==1)
				    ElementHead=insert_element(yypvt[-3].svalue,ElementHead,IND,PinHead,yypvt[-0].fvalue,"",0.0,0.0); 
				    else
				    element_list_header = insert_element(yypvt[-3].svalue,element_list_header,IND,PinHead,yypvt[-0].fvalue,"",0.0,0.0);
				    } break;
case 32:
# line 121 "bas.y"
{PinHead=insert_node(NULL,yypvt[-2].svalue);
                                    PinHead=insert_node(PinHead,yypvt[-1].svalue);
				    if(flag==1)
                                    ElementHead=insert_element(yypvt[-3].svalue,ElementHead,VS,PinHead,yypvt[-0].fvalue,"",0.0,0.0); 
				    else
				    element_list_header = insert_element(yypvt[-3].svalue,element_list_header,VS,PinHead,yypvt[-0].fvalue,"",0.0,0.0);
				    } break;
case 33:
# line 132 "bas.y"
{ActionHead = insert_action(ActionHead,PRINT_TYPE,0.0,0.0,yypvt[-1].ivalue,0.0,0.0,0.0,"yz"); } break;
case 34:
# line 134 "bas.y"
{ActionHead = insert_action(ActionHead,OPTION_TYPE,0,0,0,0,0,0,"yz"); } break;
case 35:
# line 138 "bas.y"
{ActionHead = insert_action(ActionHead,END_TYPE,0.0,0.0,0,0,0,0,yypvt[-0].svalue); } break;
case 36:
# line 142 "bas.y"
{ insert_inout( subname ); } break;
case 37:
# line 145 "bas.y"
{ insert_terminal(macromodelname); 
			 flag=0;
		       } break;
case 38:
# line 151 "bas.y"
{	if(flag == 1)
				ModelHead = insert_model(ModelHead, DIOD_TYPE, yypvt[-7].svalue,yypvt[-6].svalue,yypvt[-3].fvalue,yypvt[-0].fvalue,0.0,0.0,0.0);
			else
				model_list_header = insert_model(model_list_header, DIOD_TYPE, yypvt[-7].svalue,yypvt[-6].svalue,yypvt[-3].fvalue,yypvt[-0].fvalue,0.0,0.0,0.0);
		} break;
case 39:
# line 159 "bas.y"
{
			if(flag==1)
				ModelHead = insert_model(ModelHead,MOSFET_TYPE, yypvt[-13].svalue,yypvt[-12].svalue,0.0,0.0,yypvt[-6].fvalue,yypvt[-3].fvalue,yypvt[-0].fvalue);
			else
				model_list_header = insert_model(model_list_header,MOSFET_TYPE, yypvt[-13].svalue,yypvt[-12].svalue,0.0,0.0,yypvt[-6].fvalue,yypvt[-3].fvalue,yypvt[-0].fvalue);
		} break;
case 40:
# line 167 "bas.y"
{ MacroModelHead = insert_macro_model(MacroModelHead, name_of_macro_model, terminal_list_header, element_list_header, mos_list_header, bipolar_list_header, model_list_header);
				terminal_list_header = NULL;
				element_list_header = NULL;
				mos_list_header = NULL;
				bipolar_list_header = NULL;
				model_list_header = NULL;
				name_of_macro_model = NULL;
				flag = 1;
			     } break;
case 41:
# line 179 "bas.y"
{ActionHead = insert_action(ActionHead,DC_TYPE,0.0,0.0,0,yypvt[-2].fvalue,yypvt[-1].fvalue,yypvt[-0].fvalue,yypvt[-3].svalue); } break;
case 42:
# line 182 "bas.y"
{PinHead=insert_node(NULL,yypvt[-2].svalue);
                                    PinHead=insert_node(PinHead,yypvt[-1].svalue);
				    if(flag==1)
                                    ElementHead=insert_element(yypvt[-3].svalue,ElementHead,IS,PinHead,yypvt[-0].fvalue,"",0.0,0.0); 
				    else
				    element_list_header = insert_element(yypvt[-3].svalue,element_list_header,IS,PinHead,yypvt[-0].fvalue,"",0.0,0.0);
				    } break;
case 43:
# line 191 "bas.y"
{PinHead=insert_node(NULL,yypvt[-4].svalue);
				      PinHead=insert_node(PinHead,yypvt[-3].svalue);
				      PinHead=insert_node(PinHead,yypvt[-2].svalue);
				      PinHead=insert_node(PinHead,yypvt[-1].svalue);
				      ElementHead=insert_element(yypvt[-5].svalue,ElementHead,E,PinHead,yypvt[-0].fvalue,"",0.0,0.0); } break;
case 44:
# line 198 "bas.y"
{PinHead=insert_node(NULL,yypvt[-4].svalue);
                                      PinHead=insert_node(PinHead,yypvt[-3].svalue);
                                      PinHead=insert_node(PinHead,yypvt[-2].svalue);
                                      PinHead=insert_node(PinHead,yypvt[-1].svalue);
                                      ElementHead=insert_element(yypvt[-5].svalue,ElementHead,G,PinHead,yypvt[-0].fvalue,"",0.0,0.0); } break;
case 45:
# line 205 "bas.y"
{PinHead=insert_node(NULL,yypvt[-4].svalue);
                                      PinHead=insert_node(PinHead,yypvt[-3].svalue);
                                      PinHead=insert_node(PinHead,yypvt[-2].svalue);
                                      PinHead=insert_node(PinHead,yypvt[-1].svalue);
                                      ElementHead=insert_element(yypvt[-5].svalue,ElementHead,F,PinHead,yypvt[-0].fvalue,"",0.0,0.0); } break;
case 46:
# line 212 "bas.y"
{PinHead=insert_node(NULL,yypvt[-4].svalue);
                                      PinHead=insert_node(PinHead,yypvt[-3].svalue);
                                      PinHead=insert_node(PinHead,yypvt[-2].svalue);
                                      PinHead=insert_node(PinHead,yypvt[-1].svalue);
                                      ElementHead=insert_element(yypvt[-5].svalue,ElementHead,H,PinHead,yypvt[-0].fvalue,"",0.0,0.0); } break;
case 47:
# line 220 "bas.y"
{PinHead = insert_node(NULL, yypvt[-2].svalue);
                                   PinHead = insert_node(PinHead, yypvt[-1].svalue);
				   if(flag==1)
                                   ElementHead = insert_element(yypvt[-3].svalue,ElementHead, D, PinHead,0.0,yypvt[-0].svalue,0.0,0.0);
				   else
				   element_list_header = insert_element(yypvt[-3].svalue,element_list_header, D, PinHead,0.0,yypvt[-0].svalue,0.0,0.0);
				} break;
case 48:
# line 230 "bas.y"
{
			if(flag==1)
			MosHead = insert_mos(MosHead, yypvt[-11].svalue, yypvt[-10].svalue, yypvt[-9].svalue, yypvt[-8].svalue, yypvt[-7].svalue, yypvt[-6].svalue, yypvt[-3].fvalue, yypvt[-0].fvalue);
			else
			mos_list_header = insert_mos(mos_list_header, yypvt[-11].svalue, yypvt[-10].svalue, yypvt[-9].svalue, yypvt[-8].svalue, yypvt[-7].svalue, yypvt[-6].svalue, yypvt[-3].fvalue, yypvt[-0].fvalue);
		} break;
case 49:
# line 239 "bas.y"
{
			if(flag==1)
			BipolarHead = insert_bipolar(BipolarHead, yypvt[-4].svalue, yypvt[-3].svalue,yypvt[-2].svalue,yypvt[-1].svalue,yypvt[-0].svalue);
			else
			bipolar_list_header = insert_bipolar(bipolar_list_header, yypvt[-4].svalue, yypvt[-3].svalue,yypvt[-2].svalue,yypvt[-1].svalue,yypvt[-0].svalue);
		} break;
# line	531 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

